Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/HeuristicLab.SimSharp-3.1.1/Plugin.cs.frame
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/HeuristicLab.SimSharp-3.1.1/Plugin.cs.frame	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/HeuristicLab.SimSharp-3.1.1/Plugin.cs.frame	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/HeuristicLab.SimSharp-3.1.1/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/HeuristicLab.SimSharp-3.1.1/Properties/AssemblyInfo.cs.frame	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/HeuristicLab.SimSharp-3.1.1/Properties/AssemblyInfo.cs.frame	(revision 17246)
@@ -10,5 +10,5 @@
 [assembly: AssemblyCompany("HEAL")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2019 HEAL")]
+[assembly: AssemblyCopyright("(c) HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Analysis/ContinuousStatistics.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Analysis/ContinuousStatistics.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Analysis/ContinuousStatistics.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Collections/Extensions.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Collections/Extensions.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Collections/Extensions.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Collections/ReverseComparer.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Collections/ReverseComparer.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Collections/ReverseComparer.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/ActiveObject.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/ActiveObject.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/ActiveObject.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Environment.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Environment.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Environment.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/AllOf.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/AllOf.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/AllOf.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/AnyOf.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/AnyOf.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/AnyOf.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/Condition.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/Condition.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/Condition.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/Event.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/Event.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/Event.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/Process.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/Process.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/Process.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/Timeout.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/Timeout.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Events/Timeout.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Exceptions/EmptyScheduleException.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Exceptions/EmptyScheduleException.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Exceptions/EmptyScheduleException.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Preempted.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Preempted.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Preempted.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Container.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Container.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Container.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/ContainerGet.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/ContainerGet.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/ContainerGet.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/ContainerPut.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/ContainerPut.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/ContainerPut.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/FilterStoreGet.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/FilterStoreGet.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/FilterStoreGet.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/PreemptiveRequest.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/PreemptiveRequest.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/PreemptiveRequest.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/Release.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/Release.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/Release.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/Request.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/Request.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/Request.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/ResourcePoolRequest.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/ResourcePoolRequest.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/ResourcePoolRequest.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/StoreGet.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/StoreGet.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/StoreGet.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/StorePut.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/StorePut.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Events/StorePut.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/FilterStore.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/FilterStore.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/FilterStore.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/PreemptiveResource.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/PreemptiveResource.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/PreemptiveResource.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/PriorityResource.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/PriorityResource.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/PriorityResource.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/PriorityStore.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/PriorityStore.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/PriorityStore.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Resource.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Resource.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Resource.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/ResourcePool.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/ResourcePool.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/ResourcePool.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Store.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Store.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Core/Resources/Store.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Properties/AssemblyInfo.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Properties/AssemblyInfo.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Properties/AssemblyInfo.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
@@ -28,5 +28,5 @@
 [assembly: AssemblyCompany("HEAL")]
 [assembly: AssemblyProduct("SimSharp")]
-[assembly: AssemblyCopyright("(c) 2002-2019 HEAL")]
+[assembly: AssemblyCopyright("(c) HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/IRandom.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/IRandom.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/IRandom.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/PcgRandom.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/PcgRandom.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/PcgRandom.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/SystemRandom.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/SystemRandom.cs	(revision 16892)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/SystemRandom.cs	(revision 17246)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* SimSharp - A .NET port of SimPy, discrete event simulation framework
-Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 
 This program is free software: you can redistribute it and/or modify